#include "Asteroid.h"

Asteroid::Asteroid()
	:
	stopMoveTime( 0 )
{
	srand(time(NULL));
	AStats.state = Moving;
	AStats.wasHitByPlayerAmmo = false;
}

void Asteroid::Move()
{	
	stopMoveTime = MoveTimer.GetTimeMilli();
	MoveTimer.StopWatch();
	float XMove =  ( AStats.XVol / 1000 ) * stopMoveTime;
	float YMove =  ( AStats.YVol / 1000 ) * stopMoveTime;
	MoveTimer.StartWatch();
	AStats.XCoord += XMove;
	AStats.YCoord += YMove;
}

void Asteroid::SetSAstStats( float X, float Y )
{
	AStats.Health = 5;
	AStats.Radius = 25;
	AStats.size = Small;
	AStats.XCoord = X;
	AStats.YCoord = Y;
	AStats.XVol = rand() % 150 - 150;
	AStats.YVol = rand() % 100;
	AStats.Damage = 1.5;
	AStats.value = 25;
	AStats.wasHitByPlayerAmmo = false;
}

void Asteroid::Init(unsigned int x, unsigned int y)
{
	AStats.size = Big;
	AStats.Health = 10;
	AStats.Radius = 50;
	AStats.value = 50;
	MoveTimer.StartWatch();
	AStats.XCoord = x;
	AStats.YCoord = y;
	AStats.XVol = rand() % 25 - 13;
	AStats.YVol = rand() % 75;
	AStats.Damage = 3;
}

void Asteroid::Transition()
{
	switch( AStats.state )
	{
	case Moving:
		Move();
		break;
	}
}

void Asteroid::SetXVol( float XVol )
{
	AStats.XVol = XVol;
}

void Asteroid::SetYVol( float YVol )
{
	AStats.YVol = YVol;
}

void Asteroid::UpdateHealth( float Damage )
{
	AStats.Health = AStats.Health - Damage;
}

void Asteroid::SetRadius( unsigned int Radius )
{
	AStats.Radius = Radius;
}

void Asteroid::SetSize( Size size )
{
	AStats.size = size;
}

void Asteroid::SetState( State state )
{
	AStats.state = state;
}

float Asteroid::GetXVol()
{
	return AStats.XVol;
}

float Asteroid::GetYVol()
{
	return AStats.YVol;
}

float Asteroid::GetDamage()
{
	return AStats.Damage;
}

float Asteroid::GetX()
{
	return AStats.XCoord;
}

float Asteroid::GetY()
{
	return AStats.YCoord;
}

float Asteroid::GetHealth()
{
	return AStats.Health;
}

unsigned int Asteroid::GetRadius()
{
	return AStats.Radius;
}

Asteroid::Size Asteroid::GetSize()
{
	return AStats.size;
}

unsigned int Asteroid::GetValue()
{
	return AStats.value;
}

void Asteroid::SetHitByAmmo( bool wasHitByAmmo )
{
	AStats.wasHitByPlayerAmmo = wasHitByAmmo;
}

bool Asteroid::GetHitByAmmo()
{
	return AStats.wasHitByPlayerAmmo;
}

void Asteroid::SetPosition( unsigned int x, unsigned int y )
{
	AStats.XCoord = x;
	AStats.YCoord = y;
}