#pragma once

#include <stdio.h>
#include <ctime>
#include "Timer.h"


class Asteroid
{
public:
	Asteroid();

	enum State
	{
		Moving
	};

	enum Size
	{
		Big,
		Small
	};
private:	
	
	struct Stats
	{
		float XCoord, YCoord;
		float XVol, YVol;
		float Health;
		float Damage;
		unsigned int Radius, value;
		State state;
		Size size;
		bool wasHitByPlayerAmmo;
	};
	Timer MoveTimer;
	Stats AStats;
	float stopMoveTime;
	
private:
	void Move();
	
public:
	void SetPosition( unsigned int x, unsigned int y );
	void Transition();
	void Init(unsigned int x, unsigned int y);
	void SetSAstStats( float X, float Y );
	void SetXVol( float XVol );
	void SetYVol( float YVol );
	void UpdateHealth( float Damage );
	void SetRadius( unsigned int Radius );
	void SetSize( Size size );
	void SetState( State state );
	float GetXVol();
	float GetYVol();
	float GetX();
	float GetY();
	float GetHealth();
	float GetDamage();
	unsigned int GetRadius();
	unsigned int GetValue();
	void SetHitByAmmo( bool wasHitByAmmo );
	bool GetHitByAmmo();
	Size GetSize();
};