#include "Level.h"

Level::Level()
	:
	imgFile(),
	audFile(),
	currentTrigger( 1 )
{
}

LPCTSTR Level::GetBGAud()
{
	return audFile;
}

LPCTSTR Level::GetBGImg()
{
	return imgFile;
}

bool Level::LoadLevel( unsigned int lIndex )
{
	unsigned int temp = 0;
	unsigned int numTriggers = 0;
	switch( lIndex )
	{
	case 1:
		numEnemySpawns = 4;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"Images\\Level01.png";
		audFile = L"\\Audio\\Level01.wav";
		temp = 4200;
		numTriggers = numEnemySpawns + 2;
		triggerList = new Trigger*[ numTriggers ];
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			unsigned int j = 3000 / numEnemySpawns * (i+1);
			eSpawn[ i ].x = 0;
			eSpawn[ i ].y = temp - j;
			eSpawn[ i ].type = ENEMY;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 2400 + 1200;
		aSpawn.type = ASTEROID;
		eBoss.x = 399;
		eBoss.y = 300;
		eBoss.type = BOSS;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
			}
			else if(i == numEnemySpawns)
			{
				triggerList[ i ] = &aSpawn;
			}
			else
			{
				triggerList[ i ] = &eBoss;
			}
			triggerList[ i ]->passed = false;
		}

		break;
	case 2:		
		numEnemySpawns = 5;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level02.png";
		audFile = L"\\Audio\\Level02.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 3:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 6;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level03.png";
		audFile = L"\\Audio\\Level03.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 4:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 7;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level04.png";
		audFile = L"\\Audio\\Level04.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 5:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 8;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level05.png";
		audFile = L"\\Audio\\Level05.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 6:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 9;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level06.png";
		audFile = L"\\Audio\\Level06.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 7:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 10;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level07.png";
		audFile = L"\\Audio\\Level07.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}

		break;
	case 8:
		if(eSpawn)
		{
			delete [] eSpawn;
		}
		numEnemySpawns = 11;
		eSpawn = new Trigger[ numEnemySpawns ];
		imgFile = L"\\Images\\Level08.png";
		audFile = L"\\Audio\\Level08.wav";

		temp = 3899;
		numTriggers = numEnemySpawns + 2;
		for(unsigned int i = 0; i < numEnemySpawns; i++)
		{
			eSpawn[ i ].x = 100;
			eSpawn[ i ].y = temp - 60;
			temp = eSpawn[ i ].y;
		}
		aSpawn.x = rand() % 799;
		aSpawn.y = rand() % 3600;

		eBoss.x = 399;
		eBoss.y = 300;
		for(unsigned int i = 0; i < numTriggers; i++)
		{
			if(i < numEnemySpawns)
			{
				triggerList[ i ] = &eSpawn[ i ];
				triggerList[ i ]->passed = false;
			}
			else if(i == numEnemySpawns + 1)
			{
				triggerList[ i ] = &aSpawn;
				triggerList[ i ]->passed = false;
			}
			else
			{
				triggerList[ i ] = &eBoss;
				triggerList[ i ]->passed = false;
			}
		}
		break;
	}
	return true;
}

void Level::ClearTrigger( bool passedTrigger )
{
	triggerList[ currentTrigger - 1 ]->passed = passedTrigger;
	currentTrigger++;
}

Level::TriggerType Level::IsAtTrigger( float x, float y)
{
	TriggerType tType = NONE;
	unsigned int numTriggers = numEnemySpawns + 2;
	for(unsigned int i = 0; i < numTriggers; i++)
	{
		if(y <= triggerList[ currentTrigger - 1]->y && !triggerList[ currentTrigger - 1]->passed)
		{
			tType = triggerList[ currentTrigger - 1]->type;
		}
	}
	return tType;
}

unsigned int Level::GetNumEnemyTriggers()
{
	return numEnemySpawns;
}

Level::Trigger Level::GetTrigger( unsigned int index  )
{
	return *triggerList[index];
}

unsigned int Level::GetCurrentTrigger()
{
	return currentTrigger;
}

Level::~Level()
{
	delete [] eSpawn;
}