#pragma once
#include <Windows.h>
class Level
{
public:
	enum TriggerType
	{
		NONE, ENEMY, ASTEROID, BOSS
	};

	struct Trigger
	{
		float x, y;
		bool passed;
		TriggerType type;
	};

	Level();
	~Level();
	TriggerType IsAtTrigger(float x, float y);
	
	LPCTSTR GetBGImg();
	LPCTSTR GetBGAud();
	bool LoadLevel( unsigned int lIndex );
	void ClearTrigger( bool passedTrigger );
	
	Trigger GetTrigger( unsigned int index );
	unsigned int GetCurrentTrigger();
	unsigned int GetNumEnemyTriggers();

protected:
	// File names of background image and background music
	LPCTSTR imgFile;
	LPCTSTR audFile;
	unsigned int numEnemySpawns;
	Trigger *eSpawn;
	Trigger eBoss;
	Trigger aSpawn;
	Trigger **triggerList;
	unsigned int currentTrigger;
};

