#include "Menu.h"

GameMenu::GameMenu( std::string fileName )
	: 
	fileName( fileName )
{

}

GameMenu::~GameMenu()
{

}

std::string GameMenu::GetImageName()
{
	return fileName;
}

void GameMenu::SetButtonState( bool IsPressed, bool IsSelected, ButtonType buttontype )
{}

GameMenu::Button* GameMenu::GetButton( ButtonType buttontype )
{
	GameMenu::Button b;
	return &b;
}

void GameMenu::SetButtonColor( DWORD R, DWORD G, DWORD B, GameMenu::ButtonType buttontype )
{}

// MainMenu/PauseMenu class
MainMenu::MainMenu( std::string fileName )
	:
	GameMenu( fileName )
{
	mStartButton.X = 100;
	mStartButton.Y = 100;
	mStartButton.X2 = 200;
	mStartButton.Y2 = 150;
	mStartButton.R = 255;
	mStartButton.G = 255;
	mStartButton.B = 255;
	mStartButton.isPressed = false;
	mStartButton.isSelected = false;
	mStartButton.Text = "Start";

	mScoreButton.X = 100;
	mScoreButton.Y = 200;
	mScoreButton.X2 = 200;
	mScoreButton.Y2 = 250;
	mScoreButton.R = 255;
	mScoreButton.G = 255;
	mScoreButton.B = 255;
	mScoreButton.isPressed = false;
	mScoreButton.isSelected = false;
	mScoreButton.Text = "Score";

	mQuitButton.X = 100;
	mQuitButton.Y = 300;
	mQuitButton.X2 = 200;
	mQuitButton.Y2 = 350;
	mQuitButton.R = 255;
	mQuitButton.G = 255;
	mQuitButton.B = 255;
	mQuitButton.isPressed = false;
	mQuitButton.isSelected = false;
	mQuitButton.Text = "Quit";

	mResume.X = 100;
	mResume.Y = 100;
	mResume.X2 = 200;
	mResume.Y2 = 150;
	mResume.R = 255;
	mResume.G = 255;
	mResume.B = 255;
	mResume.isPressed = false;
	mResume.isSelected = false;
	mResume.Text = "Resume";
		
	mOptions.X = 100;
	mOptions.Y = 400;
	mOptions.X2 = 200;
	mOptions.Y2 = 450;
	mOptions.R = 255;
	mOptions.G = 255;
	mOptions.B = 255;
	mOptions.isPressed = false;
	mOptions.isSelected = false;
	mOptions.Text = "Options";
}

MainMenu::~MainMenu()
{

}

void MainMenu::SetButtonColor( DWORD R, DWORD G, DWORD B, MainMenu::ButtonType buttontype )
{
	switch( buttontype )
	{
	case Start:
			mStartButton.R = R;
			mStartButton.G = G;
			mStartButton.B = B;
			break;
	case Score:
			mScoreButton.R = R;
			mScoreButton.G = G;
			mScoreButton.B = B;
			break;

	case Quit:
			mQuitButton.R = R;
			mQuitButton.G = G;
			mQuitButton.B = B;
			break;
	}
}

MainMenu::Button* MainMenu::GetButton( ButtonType buttontype )
{
	switch( buttontype )
	{

	case Start:
		{
			return &mStartButton;
		}

	case Score:
		{
			return &mScoreButton;
		}

	case Quit:
		{
			return &mQuitButton;
		}

	}
}

void MainMenu::SetButtonState( bool IsPressed, bool IsSelected, ButtonType buttontype )
{
	switch( buttontype )
	{
	case (Start):
		{
			mStartButton.isPressed = IsPressed;
			mStartButton.isSelected = IsSelected;
			break;
		}

	case (Score):
		{
			mScoreButton.isPressed = IsPressed;
			mScoreButton.isSelected = IsSelected;
			break;
		}

	case (Quit):
		{
			mQuitButton.isPressed = IsPressed;
			mQuitButton.isSelected = IsSelected;
			break;
		}
	}
}

// ScoreMenu class
ScoreMenu::ScoreMenu( std::string fileName )
	:
	GameMenu( fileName ),
	LSize( 0 )
{
	mBackButton.X = 600;
	mBackButton.Y = 50;
	mBackButton.X2 = 700;
	mBackButton.Y2 = 100;
	mBackButton.R = 255;
	mBackButton.G = 255;
	mBackButton.B = 255;
	mBackButton.isPressed = false;
	mBackButton.isSelected = false;
	mBackButton.Text = "Back";

	pfile = fopen( "ScoreBoard.txt", "r" );
	if( pfile )
	{
		fseek( pfile,2,SEEK_CUR );
		fgetc( pfile );
		LoadScoreList();
	}
}

void ScoreMenu::SetButtonColor( DWORD R, DWORD G, DWORD B, ScoreMenu::ButtonType buttontype )
{
	switch( buttontype )
	{
	case Back:
			mBackButton.R = R;
			mBackButton.G = G;
			mBackButton.B = B;
			break;
	}
}

void ScoreMenu::SetButtonState( bool IsPressed, bool IsSelected, ButtonType buttontype )
{
	switch( buttontype )
	{
	case Back:
			mBackButton.isPressed = IsPressed;
			mBackButton.isSelected = IsSelected;
			break;
	}
}

ScoreMenu::Button* ScoreMenu::GetButton( ButtonType buttontype )
{
	switch( buttontype )
	{
	case Back:
			return &mBackButton;
			break;
	}
}

ScoreMenu::~ScoreMenu()
{
	list.clear();
}

std::vector< ScoreMenu::ScoreList > ScoreMenu::GetScoreList()
{
	return list;
}

void ScoreMenu::AddScore( std::string Name, std::string Date, unsigned int Score )
{
	list.push_back( scorelist );
	list[ LSize ].Date = Date;
	list[ LSize ].Name = Name;
	list[ LSize ].Score = Score;
	LSize++;
}

void ScoreMenu::LoadScoreList()
{
	if( pfile )
	{
		while( !feof( pfile ) )
		{
			unsigned int score;
			std::string date;
			std::string name;
			fscanf( pfile,"%s %d %s",name.c_str(),&score,date.c_str() );
			AddScore( name.c_str(), date.c_str(), score );
			fseek( pfile,4,SEEK_CUR );
			fgetc( pfile );	
		}
		fclose( pfile );
	}
}

void ScoreMenu::SortScoreList()
{
	for( int index = 0; index < LSize; index++ )
	{
		for( int a = 0; a < LSize; a++ )
		{
			if( list[ a ].Score < list[ index ].Score )
			{
				ScoreList buffer = list[ index ];
				list[ index ] = list[ a ];
				list[ a ] = buffer;
			}
		}
	}
	for( int index = 0; index < LSize; index++ )
	{
		char buffer[ 75 ];
		sprintf( buffer,"%d.\t%s\t%d\t%s\n",(index + 1), list[index].Name.c_str(), list[ index ].Score,list[ index ].Date.c_str() );
		list[ index ].Text = buffer;
	}
	
}

void ScoreMenu::SaveScoreList()
{
	SortScoreList();
	pfile = fopen( "ScoreBoard.txt", "w" );
	for( int index = 0; index < LSize; index++ )
	{
		fprintf( pfile,"%s", list[ index ].Text.c_str() );
	}
	fclose( pfile );
}

std::string ScoreMenu::GetTime()
{
	char buffer[ 20 ];
	time_t curTime = ::time( NULL );
	strftime( buffer, 20, "%X/%x",localtime( &curTime ) );
	std::string time = buffer;
	return time;
}

// OptionsMenu class
OptionsMenu::OptionsMenu()
	:
	GameMenu( fileName )
{
	fileName = "options.txt";
	LoadConfig();
}

void OptionsMenu::LoadConfig()
{
	//FILE *pFile = fopen(fileName, "r");
	char* temp = new char[10];

	std::ifstream cFile;
	cFile.open(fileName, std::ios::in);
	
	if(!cFile.is_open())
	{
		// Set defaults
		controller = "kbd";

		keyAssign[UP] = "up";
		keyAssign[DOWN] = "down";
		keyAssign[LEFT] = "left";
		keyAssign[RIGHT] = "right";
		keyAssign[FIRE] = "space";

		resX = 800;
		resY = 600;
		fScreen = false;

		mVolume = 1.0f;
		sfxVolume = 1.0f;
	}
	else
	{		
		// fscanf(pFile, "%s", controller);
		/*fscanf(pFile, "%s", keyAssign[UP]);
		fscanf(pFile, "%s", keyAssign[DOWN]);
		fscanf(pFile, "%s", keyAssign[LEFT]);
		fscanf(pFile, "%s", keyAssign[RIGHT]);
		fscanf(pFile, "%s", keyAssign[FIRE]);*/
		/*fscanf(pFile, "%d", resX);
		fscanf(pFile, "%d", resY);
		fscanf(pFile, "%d", fScreen);
		fscanf(pFile, "%f", mVolume);
		fscanf(pFile, "%f", sfxVolume);*/
		
		cFile.getline(controller, 10);
		cFile.getline(keyAssign[UP], 10);
		cFile.getline(keyAssign[DOWN], 10);
		cFile.getline(keyAssign[LEFT], 10);
		cFile.getline(keyAssign[RIGHT], 10);
		cFile.getline(keyAssign[FIRE], 10);
		cFile.getline(temp, 4);
		resX = atoi(temp);
		cFile.getline(temp, 4);
		resY = atoi(temp);
		cFile.getline(temp, 1);
		if(temp)
		{
			fScreen = true;
		}
		else
		{
			fScreen = false;
		}
		cFile.getline(temp, 5);
		mVolume = atof(temp);
		cFile.getline(temp, 5);
		sfxVolume = atof(temp);
	}
	cFile.close();
	delete [] temp;

	//fclose( pFile);
}

void OptionsMenu::GetControlsOptions( char* controllerType, char** keyAssignments )
{
	 controllerType = controller;
	 keyAssignments = keyAssign;
}

void OptionsMenu::GetGraphicsOptions( unsigned int* scrnRes, bool isFullScreen )
{
	scrnRes[0] = resX;
	scrnRes[1] = resY;
	isFullScreen = fScreen;
}

void OptionsMenu::GetSoundOptions( float musicVolume, float sfxVolume )
{
	musicVolume = mVolume;
	sfxVolume = this->sfxVolume;
}

void OptionsMenu::SaveConfig()
{
	/*FILE *pFile = fopen(fileName, "w");
	
	fprintf(pFile, "%s", controller);
	fprintf(pFile, "%s", keyAssign[UP]);
	fprintf(pFile, "%s", keyAssign[DOWN]);
	fprintf(pFile, "%s", keyAssign[LEFT]);
	fprintf(pFile, "%s", keyAssign[RIGHT]);
	fprintf(pFile, "%s", keyAssign[FIRE]);
	fprintf(pFile, "%d", resX);
	fprintf(pFile, "%d", resY);
	fprintf(pFile, "%d", fScreen);
	fprintf(pFile, "%f", mVolume);
	fprintf(pFile, "%f", sfxVolume);*/
	char *temp = new char[ 10 ];
	std::ofstream cFile;
	cFile.open(fileName, std::ios::out);
	cFile << controller;
	cFile << keyAssign[UP];
	cFile << keyAssign[DOWN];
	cFile << keyAssign[LEFT];
	cFile << keyAssign[RIGHT];
	cFile << keyAssign[FIRE];
	sprintf(temp, "%d", resX);
	cFile << temp;
	sprintf(temp, "%d", resY);
	cFile << temp;
	if(fScreen)
	{
		temp[0] = 1;
	}
	else
	{
		temp[0] = 0;
	}
	cFile << temp;
	sprintf(temp, "%f", mVolume);
	cFile << temp;
	sprintf(temp, "%f", sfxVolume);
	cFile << temp;

	cFile.close();
	delete [] temp;
}

OptionsMenu::~OptionsMenu()
{
	SaveConfig();
}

