#pragma once
#include "Timer.h"

class Projectile
{
public:
	Projectile();
	Projectile( int originX,  int originY);
	~Projectile(void);
	
	void Move( bool isFromPlayer);
	bool HasTimeToLive();

	Timer timer;
	float x, y, speed, TTL;
	float startLiveTime, stopLiveTime, startMoveTime, stopMoveTime;
};

class Missile : public Projectile
{
public:
	enum State
	{
		None,
		Acquire,
		Launched,
		Explode,
		Reset
	};
	Missile();
	Missile( int targetX,  int targetY);
	void DoState( int targetX,  int targetY, bool canFire);
	void SetMissileState( State state );
	int GetX() const;
	int GetY() const;
	int GetMIR() const;
	const float GetDamage();
	bool HasExploded();
private:
	void DecideState();
	void DestroyMissiles();	
	void Exploded();
	void ResetMissile();
	void LaunchMissiles();
	void AcquireTarget( int targetX,  int targetY);
	State mState;
	float LaunchTimer, ExplodeTimer, frameTimer;
	const float explodeDuration;
	const float MIR;									//Missile Impact Radius
	const float MissileD;								//Missile Damage
	bool Fired, targetAcquired;
	Timer mTimer;
};